//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
	
	using System.Net;
	using System.Net.Sockets;
	using System.Threading;
	using System.Text;
    
    public partial class TCPClientScript
	{
		public static EthClient ethClient = null;
		
		static TCPClientScript()
		{
			ethClient = new EthClient();
		}
		
		public static void Send(string outStr) 
		{
			if (ethClient == null) { return; }
			if (ethClient.IsConnected() == false) { return; }
			ethClient.Send(outStr);
		}
		
		public static void CloseConnection()
		{
			if (ethClient == null) { return; }
			if (ethClient.IsConnected() == false) { return; }	
			ethClient.Close();
		}

		public static void OpenConnection()
		{
			if (ethClient == null) { return; }
			ethClient.Connect();
		}
	}
	
	public class EthClient
	{
		private readonly IPAddress targetIP = new IPAddress(new byte[] {10,50,2,17});
		private readonly int targetPort = 2000;
		
		private TcpClient tcpClient = null;
		private Thread clientThread = null;		
		
		public EthClient()
		{
			try {
				Connect();
			}
			catch (Exception ex) {
				MessageBox.Show("EthClient(), " + ex.Message);
			}
		}
		
		public bool IsConnected()
		{
			if (tcpClient != null) {
				if (tcpClient.Client.Connected) {
					return true;
				}
			}
			return false;
		}
		
		public void Close()
		{
			try {
				if (tcpClient == null) { return; }
				tcpClient.Close();
				tcpClient = null;
				clientThread.Abort();
				clientThread = null;
			}
			catch (Exception) {
			}
		}
		
		public void Connect()
		{
			if (tcpClient == null) {
				tcpClient = new TcpClient();
			}
			if (tcpClient.Client.Connected) {
				return;
			}
			try {
				tcpClient.Connect(targetIP, targetPort);
			}
			catch (Exception ex) {
				MessageBox.Show("Connect(), " + ex.Message);
			}
			if (clientThread == null) {
				clientThread = new Thread(new ThreadStart(DataReceive));
				clientThread.Start();
			}			
		}
		
		private void DataReceive()
		{
			try {
				while (true) 
				{
					if (tcpClient.Client.Connected) {
						byte[] data = new byte[10000];
						int dataLen = 0;
						dataLen = tcpClient.Client.Receive(data);
						if (dataLen > 0) {
							byte[] pkt = new byte[dataLen];
							Array.Copy(data, pkt, dataLen);
							Globals.Tags.Tag1.Value = new string(Encoding.Default.GetChars(pkt));
						}
					}
				}
			}
			catch (Exception) {
				//MessageBox.Show("DataReceive(), " + ex.Message);
			}
		}
		
		public void Send(string outStr) 
		{
			try {
				if (tcpClient == null) { return; }
				if (tcpClient.Client.Connected == false) { return; }
				tcpClient.Client.Send(Encoding.Default.GetBytes(outStr));
				//tcpClient.Client.Send(Encoding.Default.GetBytes(outStr), outStr.Length, System.Net.Sockets.SocketFlags.None);
			}
			catch (Exception ex) {
				MessageBox.Show("Send(..), " + ex.Message);
			}
		}			
	}
}
